﻿using Infragistics.Controls.Editors;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }
    }

    public class VM : INotifyPropertyChanged
    {
        public VM()
        {
            Regions = new ObservableCollection<IdentifierDetail>
            {
                new IdentifierDetail { Id = "0", Name = "name0" },
                new IdentifierDetail { Id = "1", Name = "name1" },
                new IdentifierDetail { Id = "2", Name = "name2" } 
            };

            SelectedRegions = new ObservableCollection<object>
            {
                new IdentifierDetail { Id = "1", Name = "name1" }
            };
        }

        public ObservableCollection<IdentifierDetail> Regions { get; set; }


        private ObservableCollection<object> _selectedRegions;

        public ObservableCollection<object> SelectedRegions
        {

            get { return _selectedRegions; }

            set
            {
                if (_selectedRegions != value)
                {
                    _selectedRegions = value;
                    OnPropertyChanged("SelectedRegions");
                }                
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        public void OnPropertyChanged(string name)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(name));
        }
    }

    public class IdentifierDetail
    {
        public string Id { get; set; }

        public string Name { get; set; }

        public override string ToString()
        {
            return !string.IsNullOrEmpty(Name) ? Name : string.Empty;
        }

        public override int GetHashCode()
        {
            return ToString().GetHashCode();
        }

        public override bool Equals(object obj)
        {
            var other = (obj as IdentifierDetail);
            if (other?.Id != null && other.Name != null)
            {
                return Id.Equals(other.Id) && Name.Equals(other.Name);
            }
            return false;
        }

        public static bool operator ==(IdentifierDetail a, IdentifierDetail b)
        {
            if (ReferenceEquals(a, b))
            {
                return true;
            }

            if (((object)a == null) || ((object)b == null))
            {
                return false;
            }

            return a.Id == b.Id && a.Name == b.Name;
        }

        public static bool operator !=(IdentifierDetail a, IdentifierDetail b)
        {
            return !(a == b);
        }
    }

}
